/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.34).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package com.owc.singularity.server.api;

import java.util.List;

import org.springdoc.core.annotations.ParameterObject;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;

import com.owc.singularity.server.model.ExecutionEnvironment;
import com.owc.singularity.server.model.NodeInformation;
import com.owc.singularity.server.model.QueryOptions;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;


@Validated
public interface EnvironmentsApi {

    @Operation(summary = "getAllEnvironments", description = "Get all available environments", tags = { "information" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "environment array", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ExecutionEnvironment.class))) })
    @GetMapping(value = "/environments", produces = { "application/json; charset=utf-8" })
    ResponseEntity<List<ExecutionEnvironment>> getAllEnvironments(@ParameterObject QueryOptions options);

    @Operation(summary = "getEnvironmentById", description = "Get the information about the specified environment", tags = { "information" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json", schema = @Schema(implementation = ExecutionEnvironment.class))),

            @ApiResponse(responseCode = "404", description = "Not Found") })
    @GetMapping(value = "/environments/{environmentId}", produces = { "application/json; charset=utf-8" })
    ResponseEntity<ExecutionEnvironment> getEnvironmentById(
            @Parameter(in = ParameterIn.PATH, description = "environment id", required = true, schema = @Schema()) @PathVariable("environmentId") String environmentId);

    @Operation(summary = "getAllNodes", description = "Get the information of all nodes of the specified environment", tags = { "information" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "nodes array", content = @Content(mediaType = "application/json", schema = @Schema(implementation = NodeInformation.class))),
            @ApiResponse(responseCode = "404", description = "Not Found") })
    @GetMapping(value = "/environments/{environmentId}/nodes", produces = { "application/json; charset=utf-8" })
    ResponseEntity<List<NodeInformation>> getAllNodes(
            @Parameter(in = ParameterIn.PATH, description = "environment id", required = true, schema = @Schema()) @PathVariable("environmentId") String environmentId,
            @ParameterObject QueryOptions options);

    @Operation(summary = "getNodeById", description = "Get the information about the specified node", tags = { "information" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "application/json", schema = @Schema(implementation = NodeInformation.class))),

            @ApiResponse(responseCode = "404", description = "Not Found") })
    @GetMapping(value = "/environments/{environmentId}/nodes/{nodeId}", produces = { "application/json; charset=utf-8" })
    ResponseEntity<NodeInformation> getNodeById(
            @Parameter(in = ParameterIn.PATH, description = "environment id", required = true, schema = @Schema()) @PathVariable("environmentId") String environmentId,
            @Parameter(in = ParameterIn.PATH, description = "node id", required = true, schema = @Schema()) @PathVariable("nodeId") String nodeId);

}
